﻿/*
** Job Arranger for ZABBIX
** Copyright (C) 2012 FitechForce, Inc. All Rights Reserved.
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
**/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;
using jp.co.ftf.jobcontroller.JobController.Form.JobManager;
using jp.co.ftf.jobcontroller.DAO;
using jp.co.ftf.jobcontroller.Common;

namespace jp.co.ftf.jobcontroller.JobController
{
    /// <summary>
    /// DuringStartupJobnetWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class DuringStartupJobnetWindow : BaseWindow
    {
        #region フィールド
        public DispatcherTimer dispatcherTimer;
        public JobArrangerWindow _jobArrangerWindow;
        private String _innerJobnetId;
        private DateTime startTime;
        /// <summary>監視時間秒で指定</summary>
        private static int TimeOut = 300;
        #endregion

        #region コンストラクタ
        public DuringStartupJobnetWindow(String innerJobnetId, JobArrangerWindow jobArrangerWindow)
        {
            InitializeComponent();
            _innerJobnetId = innerJobnetId;
            _jobArrangerWindow = jobArrangerWindow;
            DataContext = this;
        }
        #endregion

        #region プロパティ

        /// <summary>クラス名</summary>
        public override string ClassName
        {
            get
            {
                return "DuringStartupJobnetWindow";
            }
        }

        /// <summary>画面ID</summary>
        public override string GamenId
        {
            get
            {
                return Consts.WINDOW_400;
            }
        }
        #endregion

        /// <summary>展開チェック開始</summary>
        public void startCheck()
        {
            dispatcherTimer = new DispatcherTimer(DispatcherPriority.Normal);
            dispatcherTimer.Interval = new TimeSpan(0, 0, 1);
            dispatcherTimer.Tick += new EventHandler(checkInvoid);
            dispatcherTimer.Start();
            startTime = DateTime.Now;
        }

        /// <summary>展開チェック</summary>
        private void checkInvoid(Object sender, EventArgs e)
        {
            if (DBUtil.IsJobnetInvoid(_innerJobnetId))
            {
                dispatcherTimer.Stop();
                this.Close();
                JobnetExecDetail detail = new JobnetExecDetail(_innerJobnetId);
                //detail.Owner = _jobArrangerWindow;
                detail.Topmost = true;
                detail.Show();
                return;
            }
            DateTime now = DateTime.Now;
            TimeSpan duration;
            duration = now - startTime;
            if (duration.TotalSeconds > TimeOut)
            {
                dispatcherTimer.Stop();
                this.Close();
            }

        }
    }
}
